<?php

namespace FiloBlu\Refilo\Model\Indexer\Core;

use FiloBlu\Refilo\Model\Adapter\Elastic;
use FiloBlu\Refilo\Model\Indexer\Core\Provider\QueryProviderInterfaceFactory;
use Magento\Framework\App\Config\ScopeConfigInterface;

class BaseElasticIndexer extends AbstractElasticIndexer
{
    /**
     * @var string
     */
    private $baseKey;
    /**
     * @var string
     */
    private $baseCollection;
    /**
     * @var bool
     */
    private $insertMode;
    /**
     * @var string
     */
    private $databaseConfigurationKey;

    /**
     * BaseMongoIndexer constructor.
     * @param SqlToMongoAdapterInterface $sqlToMongoAdapter
     * @param QueryProviderInterfaceFactory $queryProviderFactory
     * @param ScopeConfigInterface $scopeConfig
     * @param Elastic $elastic
     * @param string $baseKey
     * @param string $baseCollection
     * @param bool $insertMode
     * @param string $databaseConfigurationKey
     */
    public function __construct(
        SqlToMongoAdapterInterface $sqlToMongoAdapter,
        QueryProviderInterfaceFactory $queryProviderFactory,
        ScopeConfigInterface $scopeConfig,
        Elastic $elastic,
        string $baseKey,
        string $baseCollection,
        bool $insertMode,
        string $databaseConfigurationKey
    ) {
        parent::__construct($sqlToMongoAdapter, $queryProviderFactory, $scopeConfig, $elastic, $databaseConfigurationKey);
        $this->baseKey = $baseKey;
        $this->baseCollection = $baseCollection;
        $this->insertMode = $insertMode;
        $this->databaseConfigurationKey = $databaseConfigurationKey;
    }

    public function getBaseKey(): string
    {
        return $this->baseKey;
    }

    public function getTargetMongoCollection(): string
    {
        return $this->baseCollection;
    }

    public function getInsertMode(): bool
    {
        return $this->insertMode;
    }

}
